# Syntax

In following subsections, we will show how to define macros in Rust.
There are three basic ideas:

- [Patterns and Designators][designators]
- [Overloading][overloading]
- [Repetition][repetition]

[designators]: macros/designators.html
[overloading]: macros/overload.html
[repetition]: macros/repeat.html
